Attribute VB_Name = "mReg"
'''''''''''''''''''''''''''''
'
' CReg
' Ȩ 2010-2014 ZX Inc.
' 汾 1.0.4
' : Windows 95+, Win9xUNICOWS
'
' : ע
'
'''''''''''''''''''''''''''''
Option Explicit

'//ע API 
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByVal pDest As Long, ByVal pSource As Long, ByVal numBytes As Long)
Private Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long

#If USE_UNICOWS Then
Private Declare Function ExpandEnvironmentStringsW Lib "unicows.dll" (ByVal lpSrc As Long, ByVal lpDst As Long, ByVal nSize As Long) As Long
Private Declare Function RegCreateKeyExW Lib "unicows.dll" (ByVal hKey As Long, ByVal lpszSubKey As Long, ByVal Reserved As Long, ByVal lpClass As Long, ByVal dwOptions As Long, ByVal samDesired As Long, ByRef lpSecurityAttributes As SECURITY_ATTRIBUTES, ByRef phkResult As Long, ByRef lpdwDisposition As Long) As Long
Private Declare Function RegDeleteKeyW Lib "unicows.dll" (ByVal hKey As Long, ByVal lpszSubKey As Long) As Long
Private Declare Function RegDeleteValueW Lib "unicows.dll" (ByVal hKey As Long, ByVal lpszValueName As Long) As Long
Private Declare Function RegEnumKeyExW Lib "unicows.dll" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpszName As Long, ByRef lpcbName As Long, ByVal lpReserved As Long, ByVal lpClass As Long, ByRef lpcbClass As Long, ByRef lpftLastWriteTime As FILETIME) As Long
Private Declare Function RegEnumValueW Lib "unicows.dll" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpszValueName As Long, ByRef lpcbValueName As Long, ByVal lpReserved As Long, ByRef lpType As Long, ByVal lpData As Long, ByRef lpcbData As Long) As Long
Private Declare Function RegOpenKeyExW Lib "unicows.dll" (ByVal hKey As Long, ByVal lpszSubKey As Long, ByVal ulOptions As Long, ByVal samDesired As Long, ByRef phkResult As Long) As Long
Private Declare Function RegQueryInfoKeyW Lib "unicows.dll" (ByVal hKey As Long, ByVal lpClass As Long, ByRef lpcbClass As Long, ByVal lpReserved As Long, ByRef lpcSubKeys As Long, ByRef lpcbMaxSubKeyLen As Long, ByRef lpcbMaxClassLen As Long, ByRef lpcValues As Long, ByRef lpcbMaxValueNameLen As Long, ByRef lpcbMaxValueLen As Long, ByRef lpcbSecurityDescriptor As Long, ByRef lpftLastWriteTime As FILETIME) As Long
Private Declare Function RegQueryValueExW Lib "unicows.dll" (ByVal hKey As Long, ByVal lpszValueName As Long, ByVal lpReserved As Long, ByRef lpType As Long, ByVal lpData As Long, ByRef lpcbData As Long) As Long
Private Declare Function RegSetValueExW Lib "unicows.dll" (ByVal hKey As Long, ByVal lpszValueName As Long, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpbData As Long, ByVal cbData As Long) As Long
#Else
Private Declare Function ExpandEnvironmentStringsW Lib "kernel32" (ByVal lpSrc As Long, ByVal lpDst As Long, ByVal nSize As Long) As Long
Private Declare Function RegCreateKeyExW Lib "advapi32.dll" (ByVal hKey As Long, ByVal lpszSubKey As Long, ByVal Reserved As Long, ByVal lpClass As Long, ByVal dwOptions As Long, ByVal samDesired As Long, ByRef lpSecurityAttributes As SECURITY_ATTRIBUTES, ByRef phkResult As Long, ByRef lpdwDisposition As Long) As Long
Private Declare Function RegDeleteKeyW Lib "advapi32.dll" (ByVal hKey As Long, ByVal lpszSubKey As Long) As Long
Private Declare Function RegDeleteValueW Lib "advapi32.dll" (ByVal hKey As Long, ByVal lpszValueName As Long) As Long
Private Declare Function RegEnumKeyExW Lib "advapi32.dll" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpszName As Long, ByRef lpcbName As Long, ByVal lpReserved As Long, ByVal lpClass As Long, ByRef lpcbClass As Long, ByRef lpftLastWriteTime As FILETIME) As Long
Private Declare Function RegEnumValueW Lib "advapi32.dll" (ByVal hKey As Long, ByVal dwIndex As Long, ByVal lpszValueName As Long, ByRef lpcbValueName As Long, ByVal lpReserved As Long, ByRef lpType As Long, ByVal lpData As Long, ByRef lpcbData As Long) As Long
Private Declare Function RegOpenKeyExW Lib "advapi32.dll" (ByVal hKey As Long, ByVal lpszSubKey As Long, ByVal ulOptions As Long, ByVal samDesired As Long, ByRef phkResult As Long) As Long
Private Declare Function RegQueryInfoKeyW Lib "advapi32.dll" (ByVal hKey As Long, ByVal lpClass As Long, ByRef lpcbClass As Long, ByVal lpReserved As Long, ByRef lpcSubKeys As Long, ByRef lpcbMaxSubKeyLen As Long, ByRef lpcbMaxClassLen As Long, ByRef lpcValues As Long, ByRef lpcbMaxValueNameLen As Long, ByRef lpcbMaxValueLen As Long, ByRef lpcbSecurityDescriptor As Long, ByRef lpftLastWriteTime As FILETIME) As Long
Private Declare Function RegQueryValueExW Lib "advapi32.dll" (ByVal hKey As Long, ByVal lpszValueName As Long, ByVal lpReserved As Long, ByRef lpType As Long, ByVal lpData As Long, ByRef lpcbData As Long) As Long
Private Declare Function RegSetValueExW Lib "advapi32.dll" (ByVal hKey As Long, ByVal lpszValueName As Long, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpbData As Long, ByVal cbData As Long) As Long
#End If

'//עṹ
Private Type SECURITY_ATTRIBUTES
    nLength As Long
    lpSecurityDescriptor As Long
    bInheritHandle As Long
End Type

Private Type FILETIME
    dwLowDateTime As Long
    dwHighDateTime As Long
End Type

'//עȨ
Const KEY_QUERY_VALUE = &H1
Const KEY_SET_VALUE = &H2
Const KEY_CREATE_SUB_KEY = &H4
Const KEY_ENUMERATE_SUB_KEYS = &H8
Const KEY_NOTIFY = &H10
Const KEY_CREATE_LINK = &H20
'//
Const KEY_READ = &H20019
Const KEY_WRITE = &H20006
Const KEY_ALL_ACCESS = &HF003F

'///ѡ
Const REG_OPTION_NON_VOLATILE = 0&
Const REG_OPTION_VOLATILE = &H1

'//Key /
Const REG_CREATED_NEW_KEY = &H1
Const REG_OPENED_EXISTING_KEY = &H2

'//Ԥȡ
Const STANDARD_RIGHTS_ALL = &H1F0000
Const SPECIFIC_RIGHTS_ALL = &HFFFF&

'//ϸ붨
Const ERROR_SUCCESS = 0&
Const ERROR_ACCESS_DENIED = 5
Const ERROR_NO_MORE_ITEMS = 259
Const ERROR_MORE_DATA = 234     '//  
Private Const ERR_NONE = 0
Private Const ERR_CREG = &H80070002


'//עֵо
Public Enum RegDataTypeEnum
    REG_UNKNOWN = -1
    REG_NONE = 0&                       '// No value type
    REG_SZ = 1                          '// Unicode nul terminated string
    REG_EXPAND_SZ = 2                   '// Unicode nul terminated string w/environment var
    REG_BINARY = 3                      '// Free form binary
    REG_DWORD = 4                       '// 32-bit number
    REG_DWORD_LITTLE_ENDIAN = 4         '// 32-bit number (same as REG_DWORD)
    REG_DWORD_BIG_ENDIAN = 5            '// 32-bit number
    REG_LINK = 6                        '// Symbolic Link (unicode)
    REG_MULTI_SZ = 7                    '// Multiple, null-delimited, double-null-terminated Unicode strings
    REG_RESOURCE_LIST = 8               '// Resource list in the resource map
    REG_FULL_RESOURCE_DESCRIPTOR = 9    '// Resource list in the hardware description
    REG_RESOURCE_REQUIREMENTS_LIST = 10
    REG_QWORD = 11
End Enum

'//עֵб
Public Enum RootKeyEnum
    HKEY_CLASSES_ROOT = &H80000000
    HKEY_CURRENT_USER = &H80000001
    HKEY_LOCAL_MACHINE = &H80000002
    HKEY_USERS = &H80000003
    HKEY_PERFORMANCE_DATA = &H80000004  '//Win2k
    HKEY_CURRENT_CONFIG = &H80000005
'    HKEY_DYN_DATA = &H80000006          '//Win9x
End Enum

Private bNoError As Boolean

Public Function RegDelete(Name As String) As Boolean
Dim hKey As Long, KeyName As String, ValueName As String
SplitName Name, hKey, KeyName, ValueName
RegDelete = DeleteRegistryValueOrKey(hKey, KeyName, ValueName)
End Function

Public Function RegRead(Name As String) As Variant
Dim hKey As Long, KeyName As String, ValueName As String
SplitName Name, hKey, KeyName, ValueName
RegRead = GetRegistryValue(hKey, KeyName, ValueName)
End Function

Public Function RegWrite(Name As String, Value As Variant, Optional ByVal ValType As RegDataTypeEnum = REG_UNKNOWN) As Boolean
Dim hKey As Long, KeyName As String, ValueName As String, RetVal As Boolean, NewValType As RegDataTypeEnum
SplitName Name, hKey, KeyName, ValueName
If ValType = REG_UNKNOWN Then
    Select Case VarType(Value)
        Case vbNull, vbEmpty
            NewValType = REG_NONE
        Case vbBoolean, vbByte, vbError, vbInteger, vbLong
            NewValType = REG_DWORD
        Case vbCurrency, vbDate, vbDouble, vbSingle
            NewValType = REG_SZ
        Case vbString
            NewValType = REG_SZ
        Case vbArray
            NewValType = REG_BINARY
        Case Else
            NewValType = REG_BINARY
    End Select
Else
    NewValType = ValType
End If
RegWrite = SetRegistryValue(hKey, KeyName, ValueName, Value, NewValType)
End Function

Private Function SetRegistryValue(ByVal hKey As RootKeyEnum, KeyName As String, ValueName As String, Value As Variant, ByVal ValueType As RegDataTypeEnum) As Boolean
    
    Dim Handle As Long
    Dim LngValue As Long
    Dim DblValue As Double
    Dim StrValue As String
    Dim BinValue() As Byte
    Dim Length As Long
    Dim RetVal As Long
    
    Dim SecAttr As SECURITY_ATTRIBUTES '//İȫ
    '// ¼ֵƺĬϰȫ
    SecAttr.nLength = Len(SecAttr) '//ṹС
    SecAttr.lpSecurityDescriptor = 0 '//ĬϰȫȨ
    SecAttr.bInheritHandle = True '//õĬֵ
    
    '// 򿪻򴴽
    'If RegOpenKeyEx(hKey, KeyName, 0, KEY_ALL_ACCESS, handle) Then Exit Function
    RetVal = RegCreateKeyExW(hKey, StrPtr(KeyName), 0, 0, REG_OPTION_NON_VOLATILE, KEY_SET_VALUE, SecAttr, Handle, RetVal)
    If RetVal Then GoTo Err1
    
    ''' Win95ĬϼֵԶREG_SZ
#If USE_UNICOWS Then
    If ValueName = "" Then ValueType = REG_SZ
#End If
    
    '// 3
    Select Case ValueType
        Case REG_DWORD
            LngValue = Value
            RetVal = RegSetValueExW(Handle, StrPtr(ValueName), 0, REG_DWORD, VarPtr(LngValue), 4)
        
        Case REG_QWORD
            DblValue = Value
            RetVal = RegSetValueExW(Handle, StrPtr(ValueName), 0, REG_QWORD, VarPtr(DblValue), 8)
        
        Case REG_SZ, REG_EXPAND_SZ, REG_MULTI_SZ
            StrValue = Value & vbNullChar
            If ValueType = REG_MULTI_SZ Then StrValue = StrValue & vbNullChar
            RetVal = RegSetValueExW(Handle, StrPtr(ValueName), 0, ValueType, StrPtr(StrValue), Len(StrValue) * 2)
        
        Case REG_BINARY
            BinValue = Value
            Length = UBound(BinValue) - LBound(BinValue) + 1
            RetVal = RegSetValueExW(Handle, StrPtr(ValueName), 0, REG_BINARY, VarPtr(BinValue(0)), Length)
        
        Case Else '// 
            'Err.Raise ERR_CREG, , "ֵֵ֧"
        
    End Select
    
    '// عرս
    RegCloseKey Handle
    
    '// дɹ
    SetRegistryValue = (RetVal = 0)
    If RetVal Then GoTo Err1
    
    Exit Function
Err1:
    If Not bNoError Then Err.Raise ERR_CREG
End Function

Private Function GetRegistryValue(ByVal hKey As RootKeyEnum, KeyName As String, ValueName As String, Optional DefaultValue As Variant = Empty) As Variant
    
    Dim Handle As Long
    Dim ResLong As Long
    Dim ResDouble As Double
    Dim ResString As String
    Dim ResBinary() As Byte
    Dim Length As Long
    Dim RetVal As Long
    Dim ValueType As Long
    
    '// ĬϽ
    GetRegistryValue = DefaultValue
    
    '// 򿪼, ˳
    If RegOpenKeyExW(hKey, StrPtr(KeyName), 0, KEY_QUERY_VALUE, Handle) Then GoTo Err1
    
    '// ׼ 1K  resBinary ڽ
    Length = 1024
    ReDim ResBinary(0 To Length - 1) As Byte
    
    '// עֵ
    RetVal = RegQueryValueExW(Handle, StrPtr(ValueName), 0, ValueType, VarPtr(ResBinary(0)), Length)
    
    '// resBinary ̫Сض
    If RetVal = ERROR_MORE_DATA Then
        '// resBinaryŴ,¶ȡ
        ReDim ResBinary(0 To Length - 1) As Byte
        RetVal = RegQueryValueExW(Handle, StrPtr(ValueName), 0, ValueType, VarPtr(ResBinary(0)), Length)
    End If
    If RetVal Then GoTo Err1
    
    '// Ӧֵ
    Select Case ValueType
        Case REG_DWORD, REG_DWORD_LITTLE_ENDIAN
            '// REG_DWORD  REG_DWORD_LITTLE_ENDIAN ͬ
            CopyMemory VarPtr(ResLong), VarPtr(ResBinary(0)), 4
            GetRegistryValue = ResLong
        
        Case REG_DWORD_BIG_ENDIAN
            '// Big Endian's ڷ-Windows, Unixϵͳ, ؼԶ̷
            CopyMemory VarPtr(ResLong), VarPtr(ResBinary(0)), 4
            GetRegistryValue = SwapEndian(ResLong)
        
        Case REG_QWORD
            CopyMemory VarPtr(ResDouble), VarPtr(ResBinary(0)), 8
            GetRegistryValue = ResDouble
        
        Case REG_SZ, REG_EXPAND_SZ
            ResString = Space$((Length - 2) / 2)
            CopyMemory StrPtr(ResString), VarPtr(ResBinary(0)), Length - 2
            If ValueType = REG_EXPAND_SZ Then
                '// ѯӦĻ
                GetRegistryValue = ExpandEnvStr(ResString)
            Else
                GetRegistryValue = ResString
            End If
        
        Case REG_MULTI_SZ
            '// ʱָ2ո
            ResString = Space$((Length - 4) / 2)
            CopyMemory StrPtr(ResString), VarPtr(ResBinary(0)), Length - 4
            GetRegistryValue = ResString
        
        Case Else '  REG_BINARY
            '// resBinary 
            If Length <> UBound(ResBinary) + 1 Then
                ReDim Preserve ResBinary(0 To Length - 1) As Byte
            End If
            GetRegistryValue = ResBinary()
        
    End Select
    
    '// ر
    RegCloseKey Handle
    
    Exit Function
Err1:
    RegCloseKey Handle
    If Not bNoError Then Err.Raise ERR_CREG
End Function

Private Function DeleteRegistryValueOrKey(ByVal hKey As RootKeyEnum, RegKeyName As String, ValueName As String) As Boolean
'//ɾעֵͼ,ɹTrue
    
    Dim lRetVal As Long      '//򿪺עķֵ
    Dim lRegHWND As Long     '//עľ
    Dim sREGSZData As String '//ѻȡֵ뻺
    Dim lSLength As Long     '//С.  ı仺СҪڵ֮
    
    If ValueName = "" Then
        lRetVal = RegDeleteKeyW(hKey, StrPtr(RegKeyName))
        If lRetVal = ERR_NONE Then DeleteRegistryValueOrKey = True Else GoTo Err1
    Else
        '//򿪼
        lRetVal = RegOpenKeyExW(hKey, StrPtr(RegKeyName), 0, KEY_SET_VALUE, lRegHWND)
        '//ɹ
        If lRetVal = ERR_NONE Then
            '//ɾֵָ
            lRetVal = RegDeleteValueW(lRegHWND, StrPtr(ValueName))  '//Ѵɾ
            '//ִɾֵFalse
            If lRetVal <> ERR_NONE Then GoTo Err1
            '//ע: ɹ򿪽رע
            lRetVal = RegCloseKey(lRegHWND)
            '//ɹر򷵻 True 
            If lRetVal = ERR_NONE Then DeleteRegistryValueOrKey = True Else GoTo Err1
        Else
            GoTo Err1
        End If
    End If
    
    Exit Function
Err1:
    If Not bNoError Then Err.Raise ERR_CREG
End Function

Private Function ExpandEnvStr(sData As String) As String
'// ѯͷضֵ
'// 磺 %PATH% 򷵻 "c:\;c:\windows;"

    Dim c As Long, s As String

    '// get the length
    c = ExpandEnvironmentStringsW(StrPtr(sData), 0, 0)

    '// չַ
    s = String$(c - 1, 0)
    c = ExpandEnvironmentStringsW(StrPtr(sData), StrPtr(s), c)

    '// ػ
    ExpandEnvStr = s

End Function

Private Sub SplitName(ByRef PathName As String, ByRef hKey As Long, ByRef KeyName As String, ByRef ValueName As String)
Dim a As Long
On Error GoTo Err1
a = InStr(PathName, "\")
If a = 0 Then GoTo Err1
Select Case Left$(PathName, a - 1)
    Case "HKCR", "HKEY_CLASSES_ROOT"
        hKey = HKEY_CLASSES_ROOT
    Case "HKCU", "HKEY_CURRENT_USER"
        hKey = HKEY_CURRENT_USER
    Case "HKLM", "HKEY_LOCAL_MACHINE"
        hKey = HKEY_LOCAL_MACHINE
    Case "HKU", "HKEY_USERS"
        hKey = HKEY_USERS
    Case "HKEY_CURRENT_CONFIG"
        hKey = HKEY_CURRENT_CONFIG
End Select
KeyName = Mid$(PathName, a + 1)
a = InStrRev(KeyName, "\")
If a = 0 Then GoTo Err1
ValueName = Mid$(KeyName, a + 1)
KeyName = Left$(KeyName, a - 1)
Exit Sub
Err1:
If Not bNoError Then Err.Raise ERR_CREG
End Sub

Private Function SwapEndian(ByVal dw As Long) As Long
'// תDWordСDWord

    CopyMemory VarPtr(SwapEndian) + 3, VarPtr(dw), 1
    CopyMemory VarPtr(SwapEndian) + 2, VarPtr(dw) + 1, 1
    CopyMemory VarPtr(SwapEndian) + 1, VarPtr(dw) + 2, 1
    CopyMemory VarPtr(SwapEndian), VarPtr(dw) + 3, 1

End Function

Private Function Trunc(s As String) As String
Dim a As Long
a = InStr(s, vbNullChar)
If a > 0 Then
    Trunc = Left$(s, a - 1)
Else
    Trunc = s
End If
End Function

